1.1. Using Razorpay APIs
To create an authorisation transaction using Razorpay APIs, you need to:1
[Create a Customer](#111-create-a-customer).
2
[Create an Order](#112-create-an-order).
3
[Create Authorisation Payment using Razorpay APIs](#113-create-an-a...
Handy Tips
1.1.1. Create a Customer
Razorpay links recurring tokens to customers using a unique identifier generated through the Customer API. You can create customers with basic information such asemail and contact and use them for various Razorpay offerings. The following endpoint creates a customer.
/customers
Sample Code
Curl
Response
Request Parameters
name
: string The name of the customer. For example, Gaurav Kumar.
email
: string The email address of the customer. For example, gaurav.kumar@example.com.
contact
: string The phone number of the customer. For example, 9876543210.
fail_existing optional
: string The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter fail_existing to get the existing customer’s details in the response. Possible values:
1(default): If a customer with the same details already exists, throws an error.0: If a customer with the same details already exists, fetches details of the existing customer.
notes optional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
Response Parameters
id
: string The unique identifier of the customer. For example cust_1Aa00000000001.
entity
: string The name of the entity. Here, it is customer.
name
: string The name of the customer. For example, Gaurav Kumar.
email
: string The email address of the customer. For example, gaurav.kumar@example.com.
contact
: string The phone number of the customer. For example, 9876543210.
notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
created_at
: integer A Unix timestamp, at which the customer was created.
You can create an order once you create a customer for the payment authorisation.
1.1.2. Create an Order
Use the Orders API to create a unique Razorpayorder_id that is associated with the authorisation transaction. The following endpoint creates an order.
/orders
Given below is the sample code to authenticate emandate with Aadhaar. Aadhaar authentication type is enabled by default for your Razorpay account.
Curl
Response
Curl
Response
Curl
Response
Authorisation transaction + auto-charge first payment
Request Parameters
amount mandatory
: integer Amount in currency subunits. For emandate, the amount should be 0.
currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
payment_capture mandatory
: boolean Determines whether the payment status should be changed to captured automatically or not. Possible values:
true: Payments are captured automatically.false: Payments are not captured automatically. You can manually capture payments using the Manually Capture Payments API.
method mandatory
: string The authorisation method. Here, it is emandate.
customer_id mandatory
: string The unique identifier of the customer to be charged. For example, cust_D0cs04OIpPPU1F.
receipt optional
: string A user-entered unique identifier of the order. For example, rcptid #1. You should map this parameter to the order_id sent by Razorpay.
notesoptional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
token
: Details related to the authorisation such as max amount and bank account information.
auth_type optional
: string Emandate type used to make the authorisation payment. Possible values:
netbankingdebitcardaadhaar
max_amount optional
: integer The maximum amount in paise a customer can be charged in a transaction. Know about the maximum and default values.
expire_at optional
: integer The Unix timestamp to indicate till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. Defaults to 40 years. The maximum value you can set is 40 years from the current date. Any value beyond this will throw an error.
notesoptional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
bank_account
: Customer’s bank account details that should be pre-filled on the checkout.
account_number optional
: string Customer’s bank account number.
account_type optional
: string Customer’s bank account type. Possible values:
savings(default)current
ifsc_code optional
: string Customer’s bank IFSC. For example UTIB0000001.
beneficiary_name optional
: string Name of the beneficiary. For example, Gaurav Kumar.
Response Parameters
id
: string A unique identifier of the order created. For example order_1Aa00000000001.
entity
: string The entity that has been created. Here it is order.
amount
: integer Amount in currency subunits. For emandate, the amount should be 0.
amount_paid
: integer The amount that has been paid.
amount_due
: integer The amount that is yet to pay.
currency
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.
receipt
: string A user-entered unique identifier of the order. For example, rcptid #1. You should map this parameter to the order_id sent by Razorpay.
status
: string The status of the order.
notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
created_at
: integer The Unix timestamp at which the order was created.
token
: Details related to the authorisation such as max amount and bank account information.
auth_type
: string Emandate type used to make the authorisation payment. Possible values:
netbankingdebitcardaadhaar
max_amount
: integer The maximum amount in paise a customer can be charged in a transaction. Know about the maximum and default values.
expire_at
: integer The Unix timestamp to indicate till when you can use the token (authorisation on the payment method) to charge the customer subsequent payments. The default value is 10 years for emandate. This value can range from the current date to 31-12-2099 (4102444799).
notes
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
bank_account
: Customer’s bank account details that should be pre-filled on the checkout.
account_number
: string Customer’s bank account number.
account_type
: string Customer’s bank account type. Possible values:
savings(default)current
ifsc_code
: string Customer’s bank IFSC. For example UTIB0000001.
beneficiary_name
: string Name of the beneficiary. For example, Gaurav Kumar.
1.1.3. Create an Authorisation Payment
Create a payment checkout form for customers to make Authorisation Transaction and register their mandate. You can use the Handler Function or Callback URL.Handler Function | Callback URL
When you use the handler function, the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature) is submitted to the Checkout Form. You need to collect these and send them to your server. | When you use a Callback URL, the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature) is submitted to the Callback URL.
Additional Checkout Fields
customer_id mandatory
: string Unique identifier of the customer created in the first step.
order_id mandatory
: string Unique identifier of the order created in the second step.
1.2. Using a Registration Link
Registration Link is an alternate way of creating an authorisation transaction. You can create a registration link using the API or Dashboard.- When you create a registration link, an invoice is automatically issued to the customer. They can use this invoice to make the authorisation payment.
- A registration link should always have an order amount (in paise) the customer will be charged when making the authorisation payment. This amount should be
0in the case of Emandate. - You can use Webhooks to get notifications about successful payments against a registration link.
Handy Tips
1.2.1. Create a Registration Link
The following endpoint creates a registration link. /subscription_registration/auth_linksRequest
Curl
Response
Request
Request Parameters
customer
: object Details of the customer to whom the registration link is sent.
name mandatory
: string Customer’s name.
email mandatory
: string Customer’s email address.
contactmandatory
: integer Customer’s contact number.
type mandatory
: string In this case, the value is link.
amount mandatory
: integer The payment amount in the smallest currency sub-unit.
currency mandatory
: string The 3-letter ISO currency code for the payment.
description mandatory
: string A description that appears on the hosted page.
subscription_registration
: Details of the authorisation payment.
method mandatory
: string The authorization method. Here, it is emandate.
auth_type optional
: string Possible values:
-
netbanking -
debitcard -
aadhaarmax_amountoptional :integerThe maximum amount, in paise, a customer can be charged in a transaction. Know about maximum and default values.
expire_at optional
: integer The Unix timestamp indicates till when you can use the token (authorization on the payment method) to charge the customer their subsequent payments. Defaults to 40 years. The maximum value you can set is 40 years from the current date. Any value beyond this will throw an error.
bank_account
: The customer’s bank account details.
beneficiary_name optional
: string Name on the beneficiary. For example Gaurav Kumar.
Response Parameters
id
: string The unique identifier of the invoice.
entity
: string The entity that has been created. Here, it is invoice.
receipt
: string A user-entered unique identifier of the invoice.
invoice_number
: string Unique number you added for internal reference.
customer_id
: string The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.
customer_details
: object Details of the customer.
id
: string The unique identifier associated with the customer to whom the invoice has been issued.
name
: string The customer’s name.
email
: string The customer’s email address.
contact
: integer The customer’s phone number.
billing_address
: string Details of the customer’s billing address.
shipping_address
: string Details of the customer’s shipping address.
order_id
: string The unique identifier of the order associated with the invoice.
line_items
: string Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.
payment_id
: string Unique identifier of a payment made against the invoice.
status
: string The status of the invoice. Possible values:
draftissuedpartially_paidpaidcancelledexpireddeleted
expire_by
: integer The Unix timestamp at which the invoice will expire.
issued_at
: integer The Unix timestamp at which the invoice was issued to the customer.
paid_at
: integer The Unix timestamp at which the payment was made.
cancelled_at
: integer The Unix timestamp at which the invoice was cancelled.
expired_at
: integer The Unix timestamp at which the invoice expired.
sms_status
: string The delivery status of the SMS notification for the invoice sent to the customer. Possible values:
pendingsent
email_status
: string The delivery status of the email notification for the invoice sent to the customer. Possible values:
pendingsent
date
: integer Timestamp, in Unix format, that indicates the issue date of the invoice.
terms
: string Any terms to be included in the invoice. Maximum of 2048 characters.
partial_payment
: boolean Indicates whether the customer can make a partial payment on the invoice. Possible values:
true: The customer can make partial payments.false(default): The customer cannot make partial payments.
amount
: integer Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is 299.95, pass the value as 29995.
amount_paid
: integer Amount paid by the customer against the invoice.
amount_due
: integer The remaining amount to be paid by the customer for the issued invoice.
currency
: string The currency associated with the invoice.
description
: string A brief description of the invoice.
notes
: object Any custom notes added to the invoice. Maximum of 2048 characters.
short_url
: string The short URL that is generated. This is the link that can be shared with the customer to receive payments.
type
: string Here, it is invoice.
comment
: string Any comments to be added in the invoice. Maximum of 2048 characters.
1.2.2. Send/Resend Notifications
The following endpoint sends/resends notifications with the short URL to the customer: /invoices/:id/notify_by/:mediumSample Code
Curl
Response
Path Parameters
idmandatory
: string The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, inv_1Aa00000000001.
medium mandatory
: string Determines through which medium you want to resend the notification. Possible values:
smsemail
Response Parameter
success
: boolean Indicates whether the notifications were sent successfully. Possible values: - true: The notifications were successfully sent via SMS, email or both.
false: The notifications were not sent.
1.2.3. Cancel a Registration Link
The following endpoint cancels a registration link. /invoices/:id/cancelHandy Tips
issued state.
Sample Code
Curl
Response
Path Parameter
id mandatory
: string The unique identifier for the invoice linked to the registration link that you want to cancel. For example, inv_1Aa00000000001.
Response Parameters
id
: string The unique identifier of the invoice.
entity
: string The entity that has been created. Here, it is invoice.
receipt
: string A user-entered unique identifier of the invoice.
invoice_number
: string Unique number you added for internal reference.
customer_id
: string The unique identifier of the customer. For example, cust_BMB3EwbqnqZ2EI.
customer_details
: object Details of the customer.
id
: string The unique identifier associated with the customer to whom the invoice has been issued.
name
: string The customer’s name.
email
: string The customer’s email address.
contact
: integer The customer’s phone number.
billing_address
: string Details of the customer’s billing address.
shipping_address
: string Details of the customer’s shipping address.
order_id
: string The unique identifier of the order associated with the invoice.
line_items
: string Details of the line item that is billed in the invoice. Maximum of 50 line items are allowed.
payment_id
: string Unique identifier of a payment made against the invoice.
status
: string The status of the invoice. Possible values:
draftissuedpartially_paidpaidcancelledexpireddeleted
expire_by
: integer The Unix timestamp at which the invoice will expire.
issued_at
: integer The Unix timestamp at which the invoice was issued to the customer.
paid_at
: integer The Unix timestamp at which the payment was made.
cancelled_at
: integer The Unix timestamp at which the invoice was cancelled.
expired_at
: integer The Unix timestamp at which the invoice expired.
sms_status
: string The delivery status of the SMS notification for the invoice sent to the customer. Possible values:
pendingsent
email_status
: string The delivery status of the email notification for the invoice sent to the customer. Possible values:
pendingsent
date
: integer Timestamp, in Unix format, that indicates the issue date of the invoice.
terms
: string Any terms to be included in the invoice. Maximum of 2048 characters.
partial_payment
: boolean Indicates whether the customer can make a partial payment on the invoice. Possible values:
true: The customer can make partial payments.false(default): The customer cannot make partial payments.
amount
: integer Amount to be paid using the invoice. Must be in the smallest unit of the currency. For example, if the amount to be received from the customer is 299.95, pass the value as 29995.
amount_paid
: integer Amount paid by the customer against the invoice.
amount_due
: integer The remaining amount to be paid by the customer for the issued invoice.
currency
: string The currency associated with the invoice.
description
: string A brief description of the invoice.
notes
: object Any custom notes added to the invoice. Maximum of 2048 characters.
short_url
: string The short URL that is generated. This is the link that can be shared with the customer to receive payments.
type
: string Here, it is invoice.
comment
: string Any comments to be added in the invoice. Maximum of 2048 characters.